<?php

ini_set('display_errors', 1);

// Set errors
$intErrors = 0;
$strErrorMsg = "";

require_once('TwitterAPIExchange.php');
require_once('GetSharedParams.php');

// Get specific parameters:

if(isset($_GET['strScreenName']) && !empty($_GET['strScreenName'])){
	$strScreenName = $_GET["strScreenName"];
} else {
    $intErrors = $intErrors + 1;
	$strErrorMsg = $strErrorMsg . "strScreenName missing, ";
}

if(isset($_GET['strCountWhat']) && !empty($_GET['strCountWhat'])){
	$strCountWhat = $_GET["strCountWhat"];
} else {
    $intErrors = $intErrors + 1;
	$strErrorMsg = $strErrorMsg . "strCountWhat missing, ";
}

if ($intErrors > 0 ) {
	echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"."\r\n";
	echo "	<users>" . "\r\n";
	echo "		<user>" . "\r\n";
	echo "			<code>params</code>" . "\r\n";
	echo "			<message>" . $intErrors  . " parameter error(s) - " . $strErrorMsg . "</message>" . "\r\n";
	echo "		</user>" . "\r\n";
	echo "	</users>";
	die;
}


/** Set access tokens here - see: https://dev.twitter.com/apps/ **/
$settings = array(
    'oauth_access_token' => $oat,
    'oauth_access_token_secret' => $oats,
    'consumer_key' => $ck,
    'consumer_secret' => $cs
);

$url = 'https://api.twitter.com/1.1/users/show.json';
$getfield = '?screen_name=' . $strScreenName;
$requestMethod = 'GET';
$twitter = new TwitterAPIExchange($settings);

$data=$twitter->setGetfield($getfield)
			 ->buildOauth($url, $requestMethod)
			 ->performRequest();

$arrayContent = json_decode($data, true);

if (array_key_exists('errors', $arrayContent)) {
	echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"."\r\n";
	echo "	<users>" . "\r\n";
	echo "		<user>" . "\r\n";
	echo "			<code>" . $arrayContent['errors'][0]['code'] . "</code>" . "\r\n";
	echo "			<message>" . $arrayContent['errors'][0]['message'] . "</message>" . "\r\n";
	echo "		</user>" . "\r\n";
	echo "	</users>";
	die;
}

echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"."\r\n";
echo "	<users>"."\r\n";
echo "		<user>"."\r\n";
echo "			<code>0</code>" . "\r\n";
echo "			<count>" . $arrayContent[$strCountWhat] . "</count>"."\r\n";
echo "		</user>"."\r\n";
echo "	</users>"

?>