<?php

ini_set('display_errors', 1);

// Set errors
$intErrors = 0;
$strErrorMsg = "";

require_once('TwitterAPIExchange.php');
require_once('GetSharedParams.php');

// Get specific parameters:


if(isset($_GET['strMessage']) && !empty($_GET['strMessage'])){
	$strMessage = $_GET["strMessage"];
} else {
    $intErrors = $intErrors + 1;
	$strErrorMsg = $strErrorMsg . "strMessage missing";
}

if ($intErrors > 0 ) {
	echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"."\r\n";
	echo "	<users>" . "\r\n";
	echo "		<user>" . "\r\n";
	echo "			<code>params</code>" . "\r\n";
	echo "			<message>" . $intErrors  . " parameter error(s) - " . $strErrorMsg . "</message>" . "\r\n";
	echo "		</user>" . "\r\n";
	echo "	</users>";
	die;
}

/** Set access tokens here - see: https://dev.twitter.com/apps/ **/
$settings = array(
    'oauth_access_token' => $oat,
    'oauth_access_token_secret' => $oats,
    'consumer_key' => $ck,
    'consumer_secret' => $cs
);

$url = 'https://api.twitter.com/1.1/statuses/update.json';
$requestMethod = 'POST';

$postfields = array(
    'status' => $strMessage
);

$twitter = new TwitterAPIExchange($settings);

$data=$twitter->buildOauth($url, $requestMethod)
             ->setPostfields($postfields)
             ->performRequest();

$arrayContent = json_decode($data, true);

echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"."\r\n";
echo "	<statuses>"."\r\n";
echo "		<status>"."\r\n";

if (array_key_exists('errors', $arrayContent)) {
	echo "			<code>" .$arrayContent['errors'][0]['code'] . "</code>" . "\r\n";
	echo "			<message>" . $arrayContent['errors'][0]['message'] . "</message>" . "\r\n";
	echo "		</status>"."\r\n";
	echo "	</statuses>";
	die;
}

echo "			<code>0</code>" . "\r\n";
echo "			<id_str>" . $arrayContent['id_str'] . "</id_str>" . "\r\n";
echo "		</status>" . "\r\n";
echo "	</statuses>" . "\r\n";

?>